#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
#include "gibbs_normal.h"
void main_normal(int *burn, int *m, int *k, int *n, double *y, double *delta,
		 double *mu0, double *kappa, double *alpha, double *gg, double *hh,
		 char **dir_z, char **dir_pz, char **dir_w, char **dir_mu, char **dir_sigma2,
		 char **dir_log_post){

  int l, nj[*k], z[*n];
  double beta, cte, mu[*k], y_sum[*k], y2_sum[*k];
  FILE *ffile_z, *ffile_pz, *ffile_w, *ffile_mu, *ffile_sigma2, *ffile_log_post;

  ffile_z = fopen(*dir_z, "w");
  ffile_pz = fopen(*dir_pz, "w");  
  ffile_w = fopen(*dir_w, "w");
  ffile_mu = fopen(*dir_mu, "w");
  ffile_sigma2 = fopen(*dir_sigma2, "w");
  ffile_log_post = fopen(*dir_log_post, "w");

    /*        Initializing Random Seed                    */
  GetRNGstate();

  /* Initializing variables */
  beta = rmygamma(*gg, *hh);
  cte = (*mu0)*(*kappa);
  for(l = 0; l < *k; l++){
    mu[l] = rnorm(*mu0, 1.0/sqrt(rmygamma(*alpha, beta)));
    nj[l] = 0;
    y_sum[l] = 0.0;
    y2_sum[l] = 0.0;
  }
  /* Initializing allocations */
  for(l = 0; l < *n; l++){
    z[l] = (*k)*unif_rand();
    nj[z[l]]++;
    y_sum[z[l]] += y[l];
    y2_sum[z[l]] +=  y[l]*y[l];
  }

  /* Gibbs Sampler (burn) */
  gibbs_normal_burn(*burn, *k, *n, y, z, nj, mu, *delta, *kappa, *alpha, &beta,
		    *gg, *hh, cte, y_sum, y2_sum);
    
  /* Gibbs sampler (store) */
  gibbs_normal(*m, *k, *n, y, z, nj, mu, *delta, *mu0, *kappa, *alpha, &beta, *gg, *hh,
	       cte, y_sum, y2_sum, ffile_z, ffile_pz, ffile_w, ffile_mu, ffile_sigma2,
	       ffile_log_post);

  /*           Writing out the Random Seed                */
  PutRNGstate();

  /*  Closing files */
  fclose(ffile_z);
  fclose(ffile_pz);
  fclose(ffile_w);
  fclose(ffile_mu);
  fclose(ffile_sigma2);
  fclose(ffile_log_post);
}