#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
void posterior_mean(int *k, int *m, double *w, double *mu, double *sigma2, char **dir_label, 
										char **dir_w, char **dir_mu, char **dir_sigma2){  
  int j, h, label[*k];
	double w_tmp[*k], mu_tmp[*k], sigma2_tmp[*k];
	FILE *ffile_label, *ffile_w, *ffile_mu, *ffile_sigma2;
	
	ffile_label = fopen(*dir_label, "r" );
  ffile_w = fopen(*dir_w, "r" );
	ffile_mu = fopen(*dir_mu, "r" ); 
	ffile_sigma2 = fopen(*dir_sigma2, "r" ); 
  
  for(h = 0; h < *m; h++){		
		for(j = 0; j < *k; j++){
			if(fscanf(ffile_label, "%d ", &label[j]) != 1){
				Rprintf("Problem reading the labels");
				exit(1);
			}
			if(fscanf(ffile_w, "%lf ", &w_tmp[j]) != 1){
				Rprintf("Problem reading the weights");
				exit(1);
			}
			if(fscanf(ffile_mu, "%lf ", &mu_tmp[j]) != 1){
				Rprintf("Problem reading the means");
				exit(1);
			}
			if(fscanf(ffile_sigma2, "%lf ", &sigma2_tmp[j]) != 1){
				Rprintf("Problem reading sigma2");
				exit(1);
			}
		}
		for(j = 0; j < *k; j++){
			w[j] += w_tmp[label[j]];
			mu[j] += mu_tmp[label[j]];
			sigma2[j] += sigma2_tmp[label[j]];
		}			
  }
  for(j = 0; j < *k; j++){
		w[j] /= (double) *m;
		mu[j] /= (double) *m;
		sigma2[j] /= (double) *m;
	}			  
  /* Closing files */
	fclose(ffile_label);
	fclose(ffile_w);
	fclose(ffile_mu);
	fclose(ffile_sigma2);	
}