#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
void classification(int *k, int *m, int *n, double *y, char **dir_label, char **dir_pz,
										char **dir_class){
  int i, j, h, *label;
  double **p, *q;  
  FILE *ffile_label, *ffile_pz, *ffile_class;
  /* To read the results of the raw Gibbs */
  ffile_label = fopen(*dir_label, "r");
  ffile_pz = fopen(*dir_pz, "r");
  /*  To store the resulting probabilities  */
	ffile_class = fopen(*dir_class, "w");

  label = Calloc(*k, int);
  q = Calloc(*k, double);
  p = Calloc(*n, double *);
  for(i = 0; i < *n; i++){
    p[i] = Calloc(*k, double);
  }
  /* Results to Analyze */
  for(h = 0; h < *m; h++){
    /* Reading results of the Gibbs sampler */
    for(j = 0; j< *k; j++){
      if(fscanf(ffile_label, "%d ", &label[j]) != 1){
				Rprintf("Problem reading the labels");
				exit(1);
      }
    }
    for(i = 0; i < *n; i++){
			for(j = 0; j < *k; j++){
				if(fscanf(ffile_pz, "%lf ", &q[j]) != 1){
					Rprintf("Problem reading pz");
					exit(1);					
				}	
      }
      for(j = 0; j < *k; j++){
				p[i][j] += q[label[j]];
			}
    }
  }
  for(i = 0; i < *n; i++){
    for(j = 0; j < *k; j++){
      fprintf(ffile_class, "%12.16f \t", p[i][j]/((double) *m));
    }
    fprintf(ffile_class, "\n");
  }  
  /* Freeing variables */
  Free(label);
  Free(q);
  for(i = 0; i < *n; i++){
    Free(p[i]);
  }
  Free(p);
  /* Closing files */
  fclose(ffile_label);
  fclose(ffile_pz);
  fclose(ffile_class);
}