#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64
#include <R.h>
#include "LSAP.h"
void data_relabel(int *k, int *n, int *m, double *y, double *mu, double *sigma2, char **dir_z, 
								 char **dir_label){  
  int j, l, i, h, label[*k], nj[*k], z;
	double **C, ysum[*k], y2sum[*k];
  FILE *ffile_z, *ffile_label;

  ffile_z = fopen(*dir_z, "r" );  
  ffile_label = fopen(*dir_label, "w");
  C = Calloc(*k, double *);  
  for(j = 0; j < *k; j++){
    C[j] = Calloc(*k, double);
		ysum [j] = 0.0;
		y2sum[j] = 0.0;
		nj[j] = 0;
  } 
  /*-----------------------------------------------------------------*/
  /* Easy Loop: reading allocations and undoing the label switching  */
  /*-----------------------------------------------------------------*/
  for(h = 0; h < *m; h++){		
    for(i = 0; i < *n; i++){
      if(fscanf(ffile_z, "%d ", &z) != 1 ){
				Rprintf("Problem reading allocations\n");
				exit(1);
      }
      ysum[z] += y[i];
      y2sum[z] += y[i]*y[i];
			nj[z]++;
    }     
    for(j = 0; j < *k; j++){
			for(l = 0; l < *k; l++){
				C[l][j] = y2sum[j] - 2.0*ysum[j]*mu[l] + ((double) nj[j])*mu[l]*mu[l];	
				C[l][j] /= sigma2[l];
				C[l][j] *= (double) nj[j];
			}
		}      
    /* Solving the assignment problem via the Hungarian method: from R (library clue)*/
    solve_LSAP(C, *k, label);

    /* Storing the new labels */
    for(j = 0; j < *k; j++){
      fprintf(ffile_label, "%d \t", label[j]);
			ysum[j] = 0.0;
			y2sum[j] = 0.0;
			nj[j] = 0;			
    }
    fprintf(ffile_label, "\n");
  }
  for(j = 0; j < *k; j++){
    Free(C[j]);    
  }
  Free(C);  
  fclose(ffile_label);
  fclose(ffile_z);
}